#ifndef CLONABLE_H
#define CLONABLE_H

struct Clonable
{
   virtual Clonable *cloner() const = 0;
   virtual ~Clonable() throw()
      { }
};

class DupClonage {};
class DupCopie {};

template <class T>
   struct traits_dup
   {
      typedef DupCopie categorie;
   };
template < >
   struct traits_dup<Clonable>
   {
      typedef DupClonage categorie;
   };

template <class T>
   T* dupliquer(const T *p, DupClonage)
      { return static_cast<T*>(p->cloner()); }
template <class T>
   T* dupliquer(const T *p, DupCopie)
      { return new T(*p); }
template <class T>
   T *dupliquer(const T *p)
      { return dupliquer(p, typename traits_dup<T>::categorie()); }

#endif
